unit U_io;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Spin, StdCtrls, U_List, Buttons;

type
  TStringElement = class
    Inhalt: string;
  end;

  TIntegerElement = class
    Inhalt: integer;
  end;

  TBooleanElement = class
    Inhalt: boolean;
  end;

  TF_LinList = class(TForm)
    Edit2: TEdit;
    B_Loeschen: TButton;
    B_Links: TButton;
    B_Rechts: TButton;
    B_AnAnfang: TButton;
    B_ansEnde: TButton;
    BitBtn1: TBitBtn;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    B_EinfVor_String: TButton;
    B_Einf_Nach_String: TButton;
    GroupBox2: TGroupBox;
    SpinEdit1: TSpinEdit;
    B_EinfVor_Integer: TButton;
    B_EinfNach_Integer: TButton;
    GroupBox3: TGroupBox;
    CheckBox1: TCheckBox;
    B_EinfVor_Boolean: TButton;
    B_EinfNach_Boolean: TButton;
    B_Aendern_String: TButton;
    B_Aendern_Integer: TButton;
    B_Aendern_Boolean: TButton;
    procedure B_EinfVor_StringClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure B_LoeschenClick(Sender: TObject);
    procedure B_LinksClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure B_EinfVor_IntegerClick(Sender: TObject);
    procedure B_EinfVor_BooleanClick(Sender: TObject);
    procedure B_Einf_Nach_StringClick(Sender: TObject);
    procedure B_EinfNach_IntegerClick(Sender: TObject);
    procedure B_EinfNach_BooleanClick(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure B_Aendern_StringClick(Sender: TObject);
    procedure B_Aendern_IntegerClick(Sender: TObject);
    procedure B_Aendern_BooleanClick(Sender: TObject);
  private
    { Private-Deklarationen }
    q: TLinList;
    procedure anzeigen;
  public
    { Public-Deklarationen }
  end;

var
  F_LinList: TF_LinList;

implementation

{$R *.DFM}


{ **** Routinen fr Oberflche **** }

procedure TF_LinList.anzeigen; { eigene Prozedur zur Darstellung der Daten     }
begin
{  if q.isEmpty
  then edit2.text:= 'Liste ist leer...'
  else} if q.isBefore
       then edit2.Text:= 'vor der Liste ->'
       else if q.isBehind
            then edit2.Text:= '<- hinter der Liste'
            else begin
                   if q.getItem is TStringElement
                   then edit2.text:= (q.getItem as TStringElement).Inhalt; { Typecasting }
                   if q.getItem is TIntegerElement
                   then edit2.text:= IntToStr(TIntegerElement(q.getItem).Inhalt); {  "   }
                   if q.getItem is TBooleanElement
                   then if TBooleanElement(q.getItem).Inhalt then edit2.text:= 'true'{  "   }
                                                             else edit2.text:= 'false';
                 end
end;

procedure TF_LinList.B_EinfVor_StringClick(Sender: TObject); { String einfgen }
var i: TStringElement;                             { Also neues Stringelement  }
begin
  i:= TStringElement.Create;                       { Stringelement erzeugen    }
  i.Inhalt:= Edit1.Text;
  q.insertBefore(i);                               { und einfgen              }
  anzeigen;
end;

procedure TF_LinList.B_EinfVor_IntegerClick(Sender: TObject); { Integer einf.  }
var i: TIntegerElement;                            { Also neues Integerelement }
begin
  i:= TIntegerElement.Create;                      { Integerelement erzeugen   }
  i.Inhalt:= SpinEdit1.Value;
  q.insertBefore(i);                               { und einfgen              }
  anzeigen;
end;

procedure TF_LinList.B_EinfVor_BooleanClick(Sender: TObject); { Bool einfgen  }
var i: TBooleanElement;                            { Also neues Boolelement    }
begin
  i:= TBooleanElement.Create;                      { Boolelement erzeugen      }
  i.inhalt:= CheckBox1.Checked;
  q.insertBefore(i);                               { und einfgen              }
  anzeigen;
end;

procedure TF_LinList.B_Einf_Nach_StringClick(Sender: TObject);
var i: TStringElement;                             { Also neues Stringelement  }
begin
  i:= TStringElement.Create;                       { Stringelement erzeugen    }
  i.Inhalt:= Edit1.Text;
  q.insertBehind(i);                               { und einfgen              }
  anzeigen;
end;

procedure TF_LinList.B_EinfNach_IntegerClick(Sender: TObject);
var i: TIntegerElement;                            { Also neues Integerelement }
begin
  i:= TIntegerElement.Create;                      { Integerelement erzeugen   }
  i.Inhalt:= SpinEdit1.Value;
  q.insertBehind(i);                               { und einfgen              }
  anzeigen;
end;

procedure TF_LinList.B_EinfNach_BooleanClick(Sender: TObject);
var i: TBooleanElement;                            { Also neues Boolelement    }
begin
  i:= TBooleanElement.Create;                      { Boolelement erzeugen      }
  i.inhalt:= CheckBox1.Checked;
  q.insertBehind(i);                               { und einfgen              }
  anzeigen;
end;

procedure TF_LinList.B_LoeschenClick(Sender: TObject);
begin
  q.getItem.Free;
  q.delete;                                      { Element aus Liste lschen }
  anzeigen;
end;

procedure TF_LinList.B_LinksClick(Sender: TObject);{ Eine Prozedur fr alle    }
                                                   { Navigationsbuttons        }
begin
  if (Sender as TButton).Caption='<'               { Wenn Button '<' gedrckt  }
  then q.previous
  else if (Sender as TButton).Caption='>'          { Wenn Button '>' gedrckt  }
       then q.next
       else if (Sender as TButton).Caption='|<'    { Wenn Button '|<' gedrckt }
            then q.toFirst
            else q.toLast;                         { Wenn Button '>|' gedrckt }

  anzeigen;
end;

procedure TF_LinList.FormCreate(Sender: TObject);
begin
  q:= TLinList.create;                             { Liste kreieren und init.  }
  anzeigen;
end;

procedure TF_LinList.BitBtn1Click(Sender: TObject);
begin
  close;
end;

procedure TF_LinList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  q.Free;                                { Liste und dessen Elemente freigeben }
end;

procedure TF_LinList.B_Aendern_StringClick(Sender: TObject);
var i: TStringElement;                             { Also neues Stringelement  }
begin
  i:= TStringElement.Create;                       { Stringelement erzeugen    }
  i.Inhalt:= Edit1.Text;
  q.update(i);                                     { und einfgen              }
  anzeigen;
end;

procedure TF_LinList.B_Aendern_IntegerClick(Sender: TObject);
var i: TIntegerElement;                            { Also neues Integerelement }
begin
  i:= TIntegerElement.Create;                      { Integerelement erzeugen   }
  i.Inhalt:= SpinEdit1.Value;
  q.update(i);                                     { und einfgen              }
  anzeigen;
end;

procedure TF_LinList.B_Aendern_BooleanClick(Sender: TObject);
var i: TBooleanElement;                            { Also neues Boolelement    }
begin
  i:= TBooleanElement.Create;                      { Boolelement erzeugen      }
  i.inhalt:= CheckBox1.Checked;
  q.update(i);                                     { und einfgen              }
  anzeigen;
end;

end.
